; usage: nozero.exe FileName

include masm32rt.inc
include \masm32\macros\ucmacros.asm
.686p
.mmx
.xmm

BLOCK_SIZE  	EQU 100000h	; 2^20	- should be accepted on all systems (-> see description of MapViewOfFile) 
LOG2_BLOCK_SIZE	EQU 20		; log2(2^20)

.data?
	ppwszArgs 	dd ?
	nArgs		dd ?
	hSrcFile	dd ?
	hMap		dd ?
	dwFileSize	dd ?
	nBlocks		dd ?
	nRestBytes	dd ?
	pBuffer		dd ?

.code
start:
	mov ppwszArgs,rv(CommandLineToArgvW,rv(GetCommandLineW),OFFSET nArgs)
	.if nArgs == 2
		.if rv(CreateFileW,[eax+4],GENERIC_WRITE or GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_READONLY,0) != INVALID_HANDLE_VALUE
			mov hSrcFile,eax
			mov dwFileSize,rv(GetFileSize,hSrcFile,0)
			.if dwFileSize == 0
				invoke CloseHandle,hSrcFile
				print "empty source file",10,13
			.else
				mov edx,dwFileSize
				mov ecx,edx
				and edx,BLOCK_SIZE-1
				shr ecx,LOG2_BLOCK_SIZE
				mov nRestBytes,edx
				mov nBlocks,ecx				
				.if rv(CreateFileMapping,hSrcFile,0,PAGE_READWRITE,0,0,0) != INVALID_HANDLE_VALUE
					mov hMap,eax
					xor edi,edi
					.while nBlocks
						.if rv(MapViewOfFile,hMap,FILE_MAP_ALL_ACCESS,0,edi,BLOCK_SIZE)
							mov esi,eax
							mov pBuffer,eax
							assume esi:ptr OWORD
							mov ecx,BLOCK_SIZE/(16*4)
							.data
								align 16
								xmm_spc 	db 16 dup (020h)
								xmm_zero 	OWORD 0
							.code
							.while ecx 
								align 8
								movdqa xmm0,[esi+0*16]
								movdqa xmm1,[esi+1*16]
								movdqa xmm2,[esi+2*16]
								movdqa xmm3,[esi+3*16]
								movdqa xmm4,xmm0
								movdqa xmm5,xmm1
								movdqa xmm6,xmm2
								movdqa xmm7,xmm3
								pcmpeqb xmm0,xmm_zero
								pcmpeqb xmm1,xmm_zero
								pcmpeqb xmm2,xmm_zero
								pcmpeqb xmm3,xmm_zero
								pand xmm0,OWORD ptr xmm_spc
								pand xmm1,OWORD ptr xmm_spc
								pand xmm2,OWORD ptr xmm_spc
								pand xmm3,OWORD ptr xmm_spc
								por xmm4,xmm0
								por xmm5,xmm1
								por xmm6,xmm2
								por xmm7,xmm3
								movdqa [esi+0*16],xmm4
								movdqa [esi+1*16],xmm5
								movdqa [esi+2*16],xmm6
								movdqa [esi+3*16],xmm7
								add esi,4*16
								dec ecx
							.endw
							.if !(rv(UnmapViewOfFile,pBuffer))
								print "error while unmapping",10,13
								jmp @error
							.endif
						.else
							print "error while mapping source file",10,13
							jmp @error
						.endif
						add edi,BLOCK_SIZE
						dec nBlocks
					.endw
					.if rv(MapViewOfFile,hMap,FILE_MAP_ALL_ACCESS,0,edi,nRestBytes)
						mov esi,eax
						mov pBuffer,eax
						assume esi:ptr OWORD
						mov ecx,nRestBytes
						.while SDWORD ptr ecx > 0 
							align 8
							movdqa xmm0,[esi+0*16]
							movdqa xmm1,[esi+1*16]
							movdqa xmm2,[esi+2*16]
							movdqa xmm3,[esi+3*16]
							movdqa xmm4,xmm0
							movdqa xmm5,xmm1
							movdqa xmm6,xmm2
							movdqa xmm7,xmm3
							pcmpeqb xmm0,xmm_zero
							pcmpeqb xmm1,xmm_zero
							pcmpeqb xmm2,xmm_zero
							pcmpeqb xmm3,xmm_zero
							pand xmm0,OWORD ptr xmm_spc
							pand xmm1,OWORD ptr xmm_spc
							pand xmm2,OWORD ptr xmm_spc
							pand xmm3,OWORD ptr xmm_spc
							por xmm4,xmm0
							por xmm5,xmm1
							por xmm6,xmm2
							por xmm7,xmm3
							movdqa [esi+0*16],xmm4
							movdqa [esi+1*16],xmm5
							movdqa [esi+2*16],xmm6
							movdqa [esi+3*16],xmm7
							add esi,4*16
							sub ecx,4*16
						.endw
						.if !(rv(UnmapViewOfFile,pBuffer))
							print "error while unmapping",10,13
							jmp @error
						.endif
					.else
						print "error while mapping source file",10,13
						jmp @error
					.endif
					invoke CloseHandle,hMap
					invoke CloseHandle,hSrcFile
					print str$(dwFileSize)
					print " Bytes written - job done",10,13
				.else
					print "can't create file mapping",10,13
					invoke CloseHandle,hSrcFile
				.endif
			.endif
		.else
			print "can't open source file",10,13
		.endif		
	.else
		print "missing argument",10,13	
	.endif

@@: jmp @F
@error:
	invoke CloseHandle,hMap
	invoke CloseHandle,hSrcFile
@@:
	inkey "press any key to continue"
	exit

end start